local gr = love.graphics

function love.load()
	love.window.setMode( 600,600)
	love.window.setTitle('Arrow')
	ang = 0
	cx,cy = 300,300
	end

function love.update(dt)
	ang = ang+dt
	x,y = orbit(cx,cy,200,75,ang)
	end

function love.draw()
	gr.circle('fill',cx,cy,5)
	gr.circle('line',x,y,10)
	arrow({cx,cy},{x,y})
	end

function love.keypressed( key )
	if key == "escape"	then love.event.quit() end
	end

function orbit( cx, cy, rx, ry, an, oa )
	local oa = oa or -math.pi/2
	local x = rx * math.cos( an+oa ) + cx
	local y = ry * math.sin( an+oa ) + cy
	return x, y
	end

function arrow( pt1, pt2, ln )		-- start, end, [length]
	local pi, sin, cos = math.pi, math.sin, math.cos
	local x1 ,y1= pt1[1], pt1[2]
	local ln	= ln and ln or 3*dist( pt1, pt2 )/4
	local hd	= 0.2 * ln
	local a0	= angle( pt1, pt2 )
	local x0 	= ln * cos( a0 ) + x1		-- {x0,y0} = arrow head
	local y0 	= ln * sin( a0 ) + y1
	gr.line( x0, y0, x1, y1 )				-- arrow shaft
	local a1	= -0.42 * pi     - a0
	local x2 	= hd * sin( a1)  + x0
	local y2 	= hd * cos( a1 ) + y0
	local a2	= -0.58 * pi     - a0
	local x3 	= hd * sin( a2 ) + x0
	local y3 	= hd * cos( a2 ) + y0
	gr.line( x0, y0, x2, y2 )				-- arrow barbs
	gr.line( x0, y0, x3, y3 )
	end

function angle( pt1, pt2 )	-- direction(radians) pt1 => pt2
	return math.atan2( pt2[2] - pt1[2], pt2[1] - pt1[1] )
	end

function dist( p1, p2 )
	return math.sqrt( ( p2[1] - p1[1] )^2 + ( p2[2] - p1[2] )^2 )
	end
